// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/jit"
	model "LAPP_ACURA_MOM_BACKEND/models/jit"
	"fmt"
	"github.com/go-xorm/xorm"
	"time"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : PackTemplateItemLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : PackTemplateItemLst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-19 10:26:40
 *
 ******************************************************************************/
type PackTemplateItemLstDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewPackTemplateItemLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个PackTemplateItemLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : PackTemplateItemLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-10-19 10:26:40
 *
 ******************************************************************************/
func NewPackTemplateItemLstDAOImplement(session *xorm.Session, plantNr int, userid string) *PackTemplateItemLstDAOImplement {
	return &PackTemplateItemLstDAOImplement{session, &meta.PackTemplateItemLst, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) InsertOne(entity *model.PackTemplateItemLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) DeleteOne(packTemplateId string, pos int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, packTemplateId, pos}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) SelectOne(packTemplateId string, pos int) (*model.PackTemplateItemLst, error) {
	var data model.PackTemplateItemLst
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, packTemplateId, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) UpdateOne(entity *model.PackTemplateItemLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.Insert
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) Insert(entities *[]model.PackTemplateItemLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.Delete
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) Delete(entities *[]model.PackTemplateItemLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.PackTemplateItemLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.Select
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.PackTemplateItemLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.PackTemplateItemLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.PackTemplateItemLst_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.PackTemplateItemLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.PackTemplateItemLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.PackTemplateItemLst_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			if orderBy == " order by " {
				orderBy += field.ColumnName
			} else {
				orderBy += ", " + field.ColumnName
			}
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.PackTemplateItemLst, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from ["+impl.meta.TableName+"]"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.Update
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) Update(entities *[]model.PackTemplateItemLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.PackTemplateItemLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.PackTemplateItemLst_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.PackTemplateItemLst_LastUser.Name)
	entity.LastUser = impl.userid
	_, err := session.Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/jit/PackTemplateItemLstDAO.InitGlobalPackTemplate
 *
 ******************************************************************************/
func (impl *PackTemplateItemLstDAOImplement) InitGlobalPackTemplate() (err error) {
	templateLstLi := make([]model.PackTemplateWithLst, 0)
	condition := fmt.Sprintf("%s = %s and %s = %s",
		meta.PackTemplateItemLst_PlantNr.ColumnName,
		meta.PackTemplate_PlantNr.ColumnName,
		meta.PackTemplateItemLst_PackTemplateId.ColumnName,
		meta.PackTemplate_PackTemplateId.ColumnName)

	parameters := []interface{}{impl.plantNr, true}
	where := fmt.Sprintf("%s = ? and %s = ?", meta.PackTemplateItemLst_PlantNr.ColumnName, meta.PackTemplate_EnabledToggle.ColumnName)
	session := impl.session.Table(impl.meta.TableName).Join("LEFT", meta.PackTemplate.TableName, condition)
	err = session.Select(fmt.Sprintf("%s.*,%s.*", meta.PackTemplate.TableName, meta.PackTemplateItemLst.TableName)).Where(where, parameters...).OrderBy(meta.PackTemplateItemLst_PlantNr.ColumnName).OrderBy(meta.PackTemplateItemLst_PackTemplateId.ColumnName).OrderBy(meta.PackTemplateItemLst_Pos.ColumnName).Find(&templateLstLi)

	if err != nil {
		return grmi.NewBusinessError("获取包装模板数据失败, error:" + err.Error())
	}
	var templateId string
	var currentTemplateHead model.PackTemplate
	model.AllPackTemplate = model.AllPackTemplateData{}
	model.AllPackTemplate.Lock.Lock()
	defer model.AllPackTemplate.Lock.Unlock()
	model.AllPackTemplate.Data = make([]model.PackTemplate, 0)
	for _, templateLst := range templateLstLi {
		if templateId == "" {
			templateId = templateLst.PackTemplate.PackTemplateId
			currentTemplateHead = templateLst.PackTemplate
			currentTemplateHead.PartIdMap = make(map[string]int)
		}
		if templateId != templateLst.PackTemplate.PackTemplateId {
			model.AllPackTemplate.Data = append(model.AllPackTemplate.Data, currentTemplateHead)
			templateId = templateLst.PackTemplate.PackTemplateId
			currentTemplateHead = templateLst.PackTemplate
			currentTemplateHead.PartIdMap = make(map[string]int)
		}
		currentTemplateHead.PartIdMap[templateLst.PackTemplateItemLst.PartId] = templateLst.PackTemplateItemLst.PlanQty
	}
	if currentTemplateHead.PackTemplateId != "" {
		model.AllPackTemplate.Data = append(model.AllPackTemplate.Data, currentTemplateHead)
	}
	model.AllPackTemplate.SyncTime = time.Now()
	return nil
}
